--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
@@ -2170,129 +2268,12 @@
 		EL(ha, "Load RISC code\n");
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
 
 /*
- * Chip diagnostics
- *	Test chip for proper operation.
- *
- * Input:
- *	ha = adapter state pointer.
- *
- * Returns:
- *	ql local function return status code.
- *
- * Context:
- *	Kernel context.
- */
-static int
-ql_chip_diag(ql_adapter_state_t *ha)
-{
-	ql_mbx_data_t	mr;
-	int		rval;
-	int32_t		retries = 4;
-	uint16_t	id;
-
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	do {
-		/* Reset ISP chip. */
-		TASK_DAEMON_LOCK(ha);
-		ha->task_daemon_flags &= ~ISP_ABORT_NEEDED;
-		TASK_DAEMON_UNLOCK(ha);
-
-		/* For ISP2200A reduce firmware load size. */
-		if (CFG_IST(ha, CFG_CTRL_2200) &&
-		    RD16_IO_REG(ha, mailbox_out[7]) == 4) {
-			ha->fw_transfer_size = 128;
-		} else {
-			ha->fw_transfer_size = REQUEST_QUEUE_SIZE;
-		}
-
-		rval = QL_SUCCESS;
-		if (!(CFG_IST(ha, CFG_CTRL_8021))) {
-			ql_reset_chip(ha);
-
-			/* Check product ID of chip */
-			mr.mb[1] = RD16_IO_REG(ha, mailbox_out[1]);
-			mr.mb[2] = RD16_IO_REG(ha, mailbox_out[2]);
-			mr.mb[3] = RD16_IO_REG(ha, mailbox_out[3]);
-
-			if (ha->device_id == 0x5432 ||
-			    ha->device_id == 0x8432) {
-				id = 0x2432;
-			} else if (ha->device_id == 0x5422 ||
-			    ha->device_id == 0x8422) {
-				id = 0x2422;
-			} else {
-				id = ha->device_id;
-			}
-
-			if (mr.mb[1] == PROD_ID_1 &&
-			    (mr.mb[2] == PROD_ID_2 || mr.mb[2] == PROD_ID_2a) &&
-			    (mr.mb[3] == PROD_ID_3 || mr.mb[3] == id)) {
-				ha->adapter_stats->revlvl.isp2200 =
-				    RD16_IO_REG(ha, mailbox_out[4]);
-				ha->adapter_stats->revlvl.risc =
-				    RD16_IO_REG(ha, mailbox_out[5]);
-				ha->adapter_stats->revlvl.frmbfr =
-				    RD16_IO_REG(ha, mailbox_out[6]);
-				ha->adapter_stats->revlvl.riscrom =
-				    RD16_IO_REG(ha, mailbox_out[7]);
-			} else {
-				cmn_err(CE_WARN, "%s(%d) - prod id failed!, "
-				    "mb1=%xh, mb2=%xh, mb3=%xh", QL_NAME,
-				    ha->instance, mr.mb[1], mr.mb[2], mr.mb[3]);
-				rval = QL_FUNCTION_FAILED;
-			}
-		} else if (!(ha->task_daemon_flags & FIRMWARE_LOADED)) {
-			break;
-		}
-
-		if (rval == QL_SUCCESS) {
-			/* Wrap Incoming Mailboxes Test. */
-			mr.mb[1] = 0xAAAA;
-			mr.mb[2] = 0x5555;
-			mr.mb[3] = 0xAA55;
-			mr.mb[4] = 0x55AA;
-			mr.mb[5] = 0xA5A5;
-			mr.mb[6] = 0x5A5A;
-			mr.mb[7] = 0x2525;
-			rval = ql_mbx_wrap_test(ha, &mr);
-			if (rval == QL_SUCCESS) {
-				if (mr.mb[1] != 0xAAAA ||
-				    mr.mb[2] != 0x5555 ||
-				    mr.mb[3] != 0xAA55 ||
-				    mr.mb[4] != 0x55AA ||
-				    mr.mb[5] != 0xA5A5 ||
-				    mr.mb[6] != 0x5A5A ||
-				    mr.mb[7] != 0x2525) {
-					rval = QL_FUNCTION_FAILED;
-					(void) ql_flash_errlog(ha,
-					    FLASH_ERRLOG_ISP_ERR, 0,
-					    RD16_IO_REG(ha, hccr),
-					    RD16_IO_REG(ha, istatus));
-				}
-			} else {
-				cmn_err(CE_WARN, "%s(%d) - reg test failed="
-				    "%xh!", QL_NAME, ha->instance, rval);
-			}
-		}
-	} while ((retries-- != 0) && (rval != QL_SUCCESS));
-
-	if (rval != QL_SUCCESS) {
-		EL(ha, "failed, rval = %xh\n", rval);
-	} else {
-		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-	}
-	return (rval);
-}
-
-/*
  * ql_load_isp_firmware
  *	Load and start RISC firmware.
  *	Uses request ring for DMA buffer.
@@ -2311,13 +2292,16 @@
 {
 	caddr_t			risc_code_address;
 	uint32_t		risc_address, risc_code_size;
-	int			rval;
+	int			rval = QL_FUNCTION_FAILED;
 	uint32_t		word_count, cnt;
 	size_t			byte_count;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
-		rval = ql_8021_load_risc(ha);
+	QL_PRINT_10(ha, "started\n");
+
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		rval = ql_8021_reset_fw(ha) == NX_DEV_READY ?
+		    QL_SUCCESS : QL_FUNCTION_FAILED;
 	} else {
 		if (CFG_IST(ha, CFG_CTRL_81XX)) {
 			ql_mps_reset(ha);
@@ -2324,10 +2308,13 @@
 		}
 
 		if (CFG_IST(ha, CFG_LOAD_FLASH_FW)) {
+			QL_PRINT_10(ha, "CFG_LOAD_FLASH_FW exit\n");
 			return (ql_load_flash_fw(ha));
 		}
 
-		QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+		if (CFG_IST(ha, CFG_CTRL_27XX)) {
+			(void) ql_2700_get_module_dmp_template(ha);
+		}
 
 		/* Load firmware segments */
 		for (cnt = 0; cnt < MAX_RISC_CODE_SEGMENTS &&
@@ -2335,10 +2322,13 @@
 
 			risc_code_address = ha->risc_fw[cnt].code;
 			risc_address = ha->risc_fw[cnt].addr;
+			if ((risc_address = ha->risc_fw[cnt].addr) == 0) {
+				continue;
+			}
 			risc_code_size = ha->risc_fw[cnt].length;
 
 			while (risc_code_size) {
-				if (CFG_IST(ha, CFG_CTRL_242581)) {
+				if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 					word_count = ha->fw_transfer_size >> 2;
 					if (word_count > risc_code_size) {
 						word_count = risc_code_size;
@@ -2345,9 +2335,11 @@
 					}
 					byte_count = word_count << 2;
 
-					ddi_rep_put32(ha->hba_buf.acc_handle,
+					ddi_rep_put32(
+					    ha->req_q[0]->req_ring.acc_handle,
 					    (uint32_t *)risc_code_address,
-					    (uint32_t *)ha->request_ring_bp,
+					    (uint32_t *)
+					    ha->req_q[0]->req_ring.bp,
 					    word_count, DDI_DEV_AUTOINCR);
 				} else {
 					word_count = ha->fw_transfer_size >> 1;
@@ -2356,18 +2348,21 @@
 					}
 					byte_count = word_count << 1;
 
-					ddi_rep_put16(ha->hba_buf.acc_handle,
+					ddi_rep_put16(
+					    ha->req_q[0]->req_ring.acc_handle,
 					    (uint16_t *)risc_code_address,
-					    (uint16_t *)ha->request_ring_bp,
+					    (uint16_t *)
+					    ha->req_q[0]->req_ring.bp,
 					    word_count, DDI_DEV_AUTOINCR);
 				}
 
-				(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-				    REQUEST_Q_BUFFER_OFFSET, byte_count,
-				    DDI_DMA_SYNC_FORDEV);
+				(void) ddi_dma_sync(
+				    ha->req_q[0]->req_ring.dma_handle,
+				    0, byte_count, DDI_DMA_SYNC_FORDEV);
 
 				rval = ql_wrt_risc_ram(ha, risc_address,
-				    ha->request_dvma, word_count);
+				    ha->req_q[0]->req_ring.cookie.dmac_laddress,
+				    word_count);
 				if (rval != QL_SUCCESS) {
 					EL(ha, "failed, load=%xh\n", rval);
 					cnt = MAX_RISC_CODE_SEGMENTS;
@@ -2380,6 +2375,7 @@
 			}
 		}
 	}
+	bzero(ha->req_q[0]->req_ring.bp, ha->fw_transfer_size);
 
 	/* Start firmware. */
 	if (rval == QL_SUCCESS) {
@@ -2390,7 +2386,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 
 	return (rval);
@@ -2414,61 +2410,77 @@
 	uint32_t	risc_address, xfer_size, count,	*bp, faddr;
 	uint32_t	risc_code_size = 0;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
-	faddr = ha->flash_data_addr | ha->flash_fw_addr;
+	if (CFG_IST(ha, CFG_CTRL_278083)) {
+		if ((rval = ql_load_flash_image(ha)) != QL_SUCCESS) {
+			EL(ha, "load_flash_image status=%xh\n", rval);
+		} else if (CFG_IST(ha, CFG_CTRL_27XX) &&
+		    (rval = ql_2700_get_flash_dmp_template(ha)) !=
+		    QL_SUCCESS) {
+			EL(ha, "get_flash_dmp_template status=%xh\n", rval);
+		}
+	} else {
+		faddr = ha->flash_data_addr | ha->flash_fw_addr;
 
-	for (seg_cnt = 0; seg_cnt < 2; seg_cnt++) {
-		xfer_size = ha->fw_transfer_size >> 2;
-		do {
-			GLOBAL_HW_LOCK();
+		for (seg_cnt = 0; seg_cnt < 2; seg_cnt++) {
+			xfer_size = ha->fw_transfer_size >> 2;
+			do {
+				GLOBAL_HW_LOCK();
 
-			/* Read data from flash. */
-			bp = (uint32_t *)ha->request_ring_bp;
-			for (count = 0; count < xfer_size; count++) {
-				rval = ql_24xx_read_flash(ha, faddr++, bp);
+				/* Read data from flash. */
+				bp = (uint32_t *)ha->req_q[0]->req_ring.bp;
+				for (count = 0; count < xfer_size; count++) {
+					rval = ql_24xx_read_flash(ha, faddr++,
+					    bp);
+					if (rval != QL_SUCCESS) {
+						break;
+					}
+					ql_chg_endian((uint8_t *)bp++, 4);
+				}
+
+				GLOBAL_HW_UNLOCK();
+
 				if (rval != QL_SUCCESS) {
+					EL(ha, "24xx_read_flash failed=%xh\n",
+					    rval);
 					break;
 				}
-				ql_chg_endian((uint8_t *)bp++, 4);
-			}
 
-			GLOBAL_HW_UNLOCK();
+				if (risc_code_size == 0) {
+					bp = (uint32_t *)
+					    ha->req_q[0]->req_ring.bp;
+					risc_address = bp[2];
+					risc_code_size = bp[3];
+					ha->risc_fw[seg_cnt].addr =
+					    risc_address;
+				}
 
-			if (rval != QL_SUCCESS) {
-				EL(ha, "24xx_read_flash failed=%xh\n", rval);
-				break;
-			}
+				if (risc_code_size < xfer_size) {
+					faddr -= xfer_size - risc_code_size;
+					xfer_size = risc_code_size;
+				}
 
-			if (risc_code_size == 0) {
-				bp = (uint32_t *)ha->request_ring_bp;
-				risc_address = bp[2];
-				risc_code_size = bp[3];
-				ha->risc_fw[seg_cnt].addr = risc_address;
-			}
+				(void) ddi_dma_sync(
+				    ha->req_q[0]->req_ring.dma_handle,
+				    0, xfer_size << 2, DDI_DMA_SYNC_FORDEV);
 
-			if (risc_code_size < xfer_size) {
-				faddr -= xfer_size - risc_code_size;
-				xfer_size = risc_code_size;
-			}
+				rval = ql_wrt_risc_ram(ha, risc_address,
+				    ha->req_q[0]->req_ring.cookie.dmac_laddress,
+				    xfer_size);
+				if (rval != QL_SUCCESS) {
+					EL(ha, "ql_wrt_risc_ram failed=%xh\n",
+					    rval);
+					break;
+				}
 
-			(void) ddi_dma_sync(ha->hba_buf.dma_handle,
-			    REQUEST_Q_BUFFER_OFFSET, xfer_size << 2,
-			    DDI_DMA_SYNC_FORDEV);
+				risc_address += xfer_size;
+				risc_code_size -= xfer_size;
+			} while (risc_code_size);
 
-			rval = ql_wrt_risc_ram(ha, risc_address,
-			    ha->request_dvma, xfer_size);
 			if (rval != QL_SUCCESS) {
-				EL(ha, "ql_wrt_risc_ram failed=%xh\n", rval);
 				break;
 			}
-
-			risc_address += xfer_size;
-			risc_code_size -= xfer_size;
-		} while (risc_code_size);
-
-		if (rval != QL_SUCCESS) {
-			break;
 		}
 	}
 
@@ -2481,7 +2493,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -2504,12 +2516,14 @@
 {
 	int			rval, rval2;
 	uint32_t		data;
-	ql_mbx_data_t		mr;
+	ql_mbx_data_t		mr = {0};
 	ql_adapter_state_t	*ha = vha->pha;
+	ql_init_24xx_cb_t	*icb =
+	    (ql_init_24xx_cb_t *)&ha->init_ctrl_blk.cb24;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		/* Save firmware version. */
 		rval = ql_get_fw_version(ha, &mr, MAILBOX_TOV);
 		ha->fw_major_version = mr.mb[1];
@@ -2526,24 +2540,43 @@
 		ha->fw_major_version = mr.mb[1];
 		ha->fw_minor_version = mr.mb[2];
 		ha->fw_subminor_version = mr.mb[3];
-		ha->fw_ext_memory_size = ((SHORT_TO_LONG(mr.mb[4], mr.mb[5]) -
+		ha->fw_ext_memory_end = SHORT_TO_LONG(mr.mb[4], mr.mb[5]);
+		ha->fw_ext_memory_size = ((ha->fw_ext_memory_end -
 		    0x100000) + 1) * 4;
-		ha->fw_attributes = mr.mb[6];
-
-		if (CFG_IST(ha, CFG_CTRL_81XX)) {
+		if (CFG_IST(ha, CFG_CTRL_278083)) {
+			ha->fw_attributes = SHORT_TO_LONG(mr.mb[6], mr.mb[15]);
+			ha->phy_fw_major_version = LSB(mr.mb[13]);
+			ha->phy_fw_minor_version = MSB(mr.mb[14]);
+			ha->phy_fw_subminor_version = LSB(mr.mb[14]);
+			ha->fw_ext_attributes = SHORT_TO_LONG(mr.mb[16],
+			    mr.mb[17]);
+		} else {
+			ha->fw_attributes = mr.mb[6];
 			ha->phy_fw_major_version = LSB(mr.mb[8]);
 			ha->phy_fw_minor_version = MSB(mr.mb[9]);
 			ha->phy_fw_subminor_version = LSB(mr.mb[9]);
-			ha->mpi_fw_major_version = LSB(mr.mb[10]);
-			ha->mpi_fw_minor_version = MSB(mr.mb[11]);
-			ha->mpi_fw_subminor_version = LSB(mr.mb[11]);
-			ha->mpi_capability_list = SHORT_TO_LONG(mr.mb[13],
-			    mr.mb[12]);
+			ha->mpi_capability_list =
+			    SHORT_TO_LONG(mr.mb[13], mr.mb[12]);
+		}
+		ha->mpi_fw_major_version = LSB(mr.mb[10]);
+		ha->mpi_fw_minor_version = MSB(mr.mb[11]);
+		ha->mpi_fw_subminor_version = LSB(mr.mb[11]);
+		if (CFG_IST(ha, CFG_CTRL_27XX)) {
+			ha->fw_shared_ram_start =
+			    SHORT_TO_LONG(mr.mb[18], mr.mb[19]);
+			ha->fw_shared_ram_end =
+			    SHORT_TO_LONG(mr.mb[20], mr.mb[21]);
+			ha->fw_ddr_ram_start =
+			    SHORT_TO_LONG(mr.mb[22], mr.mb[23]);
+			ha->fw_ddr_ram_end =
+			    SHORT_TO_LONG(mr.mb[24], mr.mb[25]);
+		}
+		if (CFG_IST(ha, CFG_FLASH_ACC_SUPPORT)) {
 			if ((rval2 = ql_flash_access(ha, FAC_GET_SECTOR_SIZE,
 			    0, 0, &data)) == QL_SUCCESS) {
 				ha->xioctl->fdesc.block_size = data << 2;
-				QL_PRINT_10(CE_CONT, "(%d): fdesc.block_size="
-				    "%xh\n", ha->instance,
+				QL_PRINT_10(ha, "fdesc.block_size="
+				    "%xh\n",
 				    ha->xioctl->fdesc.block_size);
 			} else {
 				EL(ha, "flash_access status=%xh\n", rval2);
@@ -2551,7 +2584,7 @@
 		}
 
 		/* Set Serdes Transmit Parameters. */
-		if (CFG_IST(ha, CFG_CTRL_2422) && ha->serdes_param[0] & BIT_0) {
+		if (CFG_IST(ha, CFG_CTRL_24XX) && ha->serdes_param[0] & BIT_0) {
 			mr.mb[1] = ha->serdes_param[0];
 			mr.mb[2] = ha->serdes_param[1];
 			mr.mb[3] = ha->serdes_param[2];
@@ -2567,12 +2600,55 @@
 			(void) ql_set_firmware_option(ha, &mr);
 		}
 	}
+
+	if (ha->flags & MULTI_QUEUE) {
+		QL_PRINT_10(ha, "MULTI_QUEUE\n");
+		icb->msi_x_vector[0] = LSB(ha->rsp_queues[0]->msi_x_vector);
+		icb->msi_x_vector[1] = MSB(ha->rsp_queues[0]->msi_x_vector);
+		if (ha->iflags & IFLG_INTR_MSIX &&
+		    CFG_IST(ha, CFG_NO_INTR_HSHAKE_SUP)) {
+			QL_PRINT_10(ha, "NO_INTR_HANDSHAKE\n");
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags |= NO_INTR_HANDSHAKE;
+			ADAPTER_STATE_UNLOCK(ha);
+			icb->firmware_options_2[2] = (uint8_t)
+			    (icb->firmware_options_2[2] & ~(BIT_6 | BIT_5));
+			icb->firmware_options_2[2] = (uint8_t)
+			    (icb->firmware_options_2[2] | BIT_7);
+		} else {
+			icb->firmware_options_2[2] = (uint8_t)
+			    (icb->firmware_options_2[2] & ~BIT_5);
+			icb->firmware_options_2[2] = (uint8_t)
+			    (icb->firmware_options_2[2] | BIT_7 | BIT_6);
+		}
+	} else {
+		icb->firmware_options_2[2] = (uint8_t)
+		    (icb->firmware_options_2[2] & ~(BIT_7 | BIT_5));
+		icb->firmware_options_2[2] = (uint8_t)
+		    (icb->firmware_options_2[2] | BIT_6);
+	}
+	icb->firmware_options_2[3] = (uint8_t)
+	    (icb->firmware_options_2[3] & ~(BIT_1 | BIT_0));
+
+	/* Set fw execution throttle. */
+	if (CFG_IST(ha, CFG_CTRL_22XX) ||
+	    ql_get_resource_cnts(ha, &mr) != QL_SUCCESS) {
+		icb->execution_throttle[0] = 0xff;
+		icb->execution_throttle[1] = 0xff;
+	} else {
+		icb->execution_throttle[0] = LSB(mr.mb[6]);
+		icb->execution_throttle[1] = MSB(mr.mb[6]);
+	}
+	EL(ha, "icb->execution_throttle %d\n",
+	    CHAR_TO_SHORT(icb->execution_throttle[0],
+	    icb->execution_throttle[1]));
+
 	if (rval != QL_SUCCESS) {
 		ha->task_daemon_flags &= ~FIRMWARE_LOADED;
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		ha->task_daemon_flags |= FIRMWARE_LOADED;
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -2593,7 +2669,7 @@
 int
 ql_set_cache_line(ql_adapter_state_t *ha)
 {
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Set the cache line. */
 	if (CFG_IST(ha->pha, CFG_SET_CACHE_LINE_SIZE_1)) {
@@ -2601,7 +2677,7 @@
 		ql_pci_config_put8(ha->pha, PCI_CONF_CACHE_LINESZ, 1);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -2614,9 +2690,10 @@
  *	already built by nvram config routine.
  *
  * Input:
- *	ha = adapter state pointer.
- *	ha->hba_buf = request and response rings
- *	ha->init_ctrl_blk = initialization control block
+ *	ha =			adapter state pointer.
+ *	ha->req_q =		request rings
+ *	ha->rsp_queues =	response rings
+ *	ha->init_ctrl_blk =	initialization control block
  *
  * Returns:
  *	ql local function return status code.
@@ -2632,10 +2709,10 @@
 	ql_mbx_data_t		mr;
 	ql_adapter_state_t	*ha = vha2->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Clear outstanding commands array. */
-	for (index = 0; index < MAX_OUTSTANDING_COMMANDS; index++) {
+	for (index = 0; index < ha->osc_max_cnt; index++) {
 		ha->outstanding_cmds[index] = NULL;
 	}
 	ha->osc_index = 1;
@@ -2644,30 +2721,35 @@
 	ha->pending_cmds.last = NULL;
 
 	/* Initialize firmware. */
-	ha->request_ring_ptr = ha->request_ring_bp;
-	ha->req_ring_index = 0;
-	ha->req_q_cnt = REQUEST_ENTRY_CNT - 1;
-	ha->response_ring_ptr = ha->response_ring_bp;
-	ha->rsp_ring_index = 0;
+	ha->req_q[0]->req_ring_ptr = ha->req_q[0]->req_ring.bp;
+	ha->req_q[0]->req_ring_index = 0;
+	ha->req_q[0]->req_q_cnt = REQUEST_ENTRY_CNT - 1;
+	ha->rsp_queues[0]->rsp_ring_ptr = ha->rsp_queues[0]->rsp_ring.bp;
+	ha->rsp_queues[0]->rsp_ring_index = 0;
 
 	if (ha->flags & VP_ENABLED) {
 		ql_adapter_state_t	*vha;
-		uint16_t		cnt;
-		uint32_t		max_vports;
 		ql_init_24xx_cb_t	*icb = &ha->init_ctrl_blk.cb24;
 
-		max_vports = (CFG_IST(ha, CFG_CTRL_2422) ?
-		    MAX_24_VIRTUAL_PORTS : MAX_25_VIRTUAL_PORTS);
 		bzero(icb->vp_count,
 		    ((uintptr_t)icb + sizeof (ql_init_24xx_cb_t)) -
 		    (uintptr_t)icb->vp_count);
-		icb->vp_count[0] = (uint8_t)max_vports;
+		icb->vp_count[0] = ha->max_vports - 1;
 
 		/* Allow connection option 2. */
 		icb->global_vp_option[0] = BIT_1;
 
-		for (cnt = 0, vha = ha->vp_next; cnt < max_vports &&
-		    vha != NULL; vha = vha->vp_next, cnt++) {
+		/* Setup default options for all ports. */
+		for (index = 0; index < ha->max_vports; index++) {
+			icb->vpc[index].options = VPO_TARGET_MODE_DISABLED |
+			    VPO_INITIATOR_MODE_ENABLED;
+		}
+		/* Setup enabled ports. */
+		for (vha = ha->vp_next; vha != NULL; vha = vha->vp_next) {
+			if (vha->vp_index == 0 ||
+			    vha->vp_index >= ha->max_vports) {
+				continue;
+			}
 
 			index = (uint8_t)(vha->vp_index - 1);
 			bcopy(vha->loginparams.node_ww_name.raw_wwn,
@@ -2675,8 +2757,6 @@
 			bcopy(vha->loginparams.nport_ww_name.raw_wwn,
 			    icb->vpc[index].port_name, 8);
 
-			icb->vpc[index].options = VPO_TARGET_MODE_DISABLED |
-			    VPO_INITIATOR_MODE_ENABLED;
 			if (vha->flags & VP_ENABLED) {
 				icb->vpc[index].options = (uint8_t)
 				    (icb->vpc[index].options | VPO_ENABLED);
@@ -2694,7 +2774,7 @@
 		}
 	}
 
-	if (rval == QL_SUCCESS && (CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+	if (rval == QL_SUCCESS && CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		/* Tell firmware to enable MBA_PORT_BYPASS_CHANGED event */
 		rval = ql_get_firmware_option(ha, &mr);
 		if (rval == QL_SUCCESS) {
@@ -2712,7 +2792,7 @@
 			EL(ha, "fcetrace buffer alloc failed: %xh\n", rval2);
 		} else {
 			if ((rval2 = ql_fw_etrace(ha, &ha->fwfcetracebuf,
-			    FTO_FCE_TRACE_ENABLE)) != QL_SUCCESS) {
+			    FTO_FCE_TRACE_ENABLE, NULL)) != QL_SUCCESS) {
 				EL(ha, "fcetrace enable failed: %xh\n", rval2);
 				ql_free_phys(ha, &ha->fwfcetracebuf);
 			}
@@ -2726,7 +2806,7 @@
 			EL(ha, "exttrace buffer alloc failed: %xh\n", rval2);
 		} else {
 			if ((rval2 = ql_fw_etrace(ha, &ha->fwexttracebuf,
-			    FTO_EXT_TRACE_ENABLE)) != QL_SUCCESS) {
+			    FTO_EXT_TRACE_ENABLE, NULL)) != QL_SUCCESS) {
 				EL(ha, "exttrace enable failed: %xh\n", rval2);
 				ql_free_phys(ha, &ha->fwexttracebuf);
 			}
@@ -2802,7 +2882,7 @@
 		TASK_DAEMON_LOCK(ha);
 		ha->task_daemon_flags |= FIRMWARE_UP;
 		TASK_DAEMON_UNLOCK(ha);
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -2826,30 +2906,46 @@
 ql_fw_ready(ql_adapter_state_t *ha, uint8_t secs)
 {
 	ql_mbx_data_t	mr;
-	clock_t		timer;
+	clock_t		timer, login_wait, wait;
 	clock_t		dly = 250000;
 	clock_t		sec_delay = MICROSEC / dly;
-	clock_t		wait = secs * sec_delay;
 	int		rval = QL_FUNCTION_FAILED;
-	uint16_t	state = 0xffff;
+	uint16_t	state[6] = {0};
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	timer = ha->r_a_tov < secs ? secs : ha->r_a_tov;
-	timer = (timer + 2) * sec_delay;
+	login_wait = ha->r_a_tov * 2 * sec_delay;
+	timer = wait = secs * sec_delay;
+	state[0] = 0xffff;
 
 	/* Wait for ISP to finish LIP */
-	while (timer != 0 && wait != 0 &&
-	    !(ha->task_daemon_flags & ISP_ABORT_NEEDED)) {
+	while (login_wait != 0 && wait != 0 &&
+	    !(ha->task_daemon_flags & ISP_ABORT_NEEDED) &&
+	    !(ha->flags & MPI_RESET_NEEDED)) {
 
 		rval = ql_get_firmware_state(ha, &mr);
 		if (rval == QL_SUCCESS) {
-			if (ha->task_daemon_flags & (ISP_ABORT_NEEDED |
-			    LOOP_DOWN)) {
-				wait--;
-			} else if (mr.mb[1] != FSTATE_READY) {
+			if (mr.mb[1] != FSTATE_READY) {
+				if (mr.mb[1] == FSTATE_LOSS_SYNC &&
+				    mr.mb[4] == FSTATE_MPI_NIC_ERROR &&
+				    CFG_IST(ha, CFG_FCOE_SUPPORT)) {
+					EL(ha, "mpi_nic_error, "
+					    "isp_abort_needed\n");
+					ADAPTER_STATE_LOCK(ha);
+					ha->flags |= MPI_RESET_NEEDED;
+					ADAPTER_STATE_UNLOCK(ha);
+					if (!(ha->task_daemon_flags &
+					    ABORT_ISP_ACTIVE)) {
+						TASK_DAEMON_LOCK(ha);
+						ha->task_daemon_flags |=
+						    ISP_ABORT_NEEDED;
+						TASK_DAEMON_UNLOCK(ha);
+					}
+				}
 				if (mr.mb[1] != FSTATE_WAIT_LOGIN) {
-					wait--;
+					timer = --wait;
+				} else {
+					timer = --login_wait;
 				}
 				rval = QL_FUNCTION_FAILED;
 			} else {
@@ -2875,16 +2971,25 @@
 				}
 			}
 		} else {
-			wait--;
+			break;
 		}
 
-		if (state != mr.mb[1]) {
-			EL(ha, "mailbox_reg[1] = %xh\n", mr.mb[1]);
-			state = mr.mb[1];
+		if (state[0] != mr.mb[1] || state[1] != mr.mb[2] ||
+		    state[2] != mr.mb[3] || state[3] != mr.mb[4] ||
+		    state[4] != mr.mb[5] || state[5] != mr.mb[6]) {
+			EL(ha, "mbx1=%xh, mbx2=%xh, mbx3=%xh, mbx4=%xh, "
+			    "mbx5=%xh, mbx6=%xh\n", mr.mb[1], mr.mb[2],
+			    mr.mb[3], mr.mb[4], mr.mb[5], mr.mb[6]);
+			state[0] = mr.mb[1];
+			state[1] = mr.mb[2];
+			state[2] = mr.mb[3];
+			state[3] = mr.mb[4];
+			state[4] = mr.mb[5];
+			state[5] = mr.mb[6];
 		}
 
 		/* Delay for a tick if waiting. */
-		if (timer-- != 0 && wait != 0) {
+		if (timer != 0) {
 			if (timer % 4 == 0) {
 				delay(drv_usectohz(dly));
 			} else {
@@ -2896,10 +3001,17 @@
 	}
 
 	if (rval != QL_SUCCESS) {
+		if ((ha->task_daemon_flags & ISP_ABORT_NEEDED ||
+		    ha->flags & MPI_RESET_NEEDED) &&
+		    ha->task_daemon_flags & LOOP_RESYNC_NEEDED) {
+			TASK_DAEMON_LOCK(ha);
+			ha->task_daemon_flags &= ~LOOP_RESYNC_NEEDED;
+			TASK_DAEMON_UNLOCK(ha);
+		}
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -2920,15 +3032,17 @@
 static int
 ql_configure_loop(ql_adapter_state_t *ha)
 {
-	int			rval;
+	int			rval = QL_SUCCESS;
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	for (vha = ha; vha != NULL; vha = vha->vp_next) {
 		TASK_DAEMON_LOCK(ha);
 		if (!(vha->task_daemon_flags & LOOP_RESYNC_NEEDED) &&
-		    vha->vp_index != 0 && !(vha->flags & VP_ENABLED)) {
+		    vha->vp_index != 0 &&
+		    (!(vha->flags & VP_ENABLED) ||
+		    vha->flags & VP_ID_NOT_ACQUIRED)) {
 			TASK_DAEMON_UNLOCK(ha);
 			continue;
 		}
@@ -2950,7 +3064,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -2967,17 +3081,24 @@
  *
  * Context:
  *	Kernel context.
+ *	ADAPTER_STATE_LOCK must be already obtained
  */
 static void
 ql_configure_n_port_info(ql_adapter_state_t *ha)
 {
-	ql_tgt_t	tmp_tq;
-	ql_tgt_t	*tq;
-	uint8_t		*cb_port_name;
-	ql_link_t	*link;
-	int		index, rval;
+	ql_tgt_t		tmp_tq;
+	ql_tgt_t		*tq;
+	uint8_t			*cb_port_name;
+	ql_link_t		*link;
+	int			index, rval;
+	uint16_t		loop_id = 0;
+	uint32_t		found = 0;
+	ql_dev_id_list_t	*list;
+	uint32_t		list_size;
+	ql_mbx_data_t		mr;
+	port_id_t		d_id = {0, 0, 0, 0};
 
-	tq = &tmp_tq;
+	QL_PRINT_10(ha, "started\n");
 
 	/* Free existing target queues. */
 	for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
@@ -2985,11 +3106,50 @@
 		while (link != NULL) {
 			tq = link->base_address;
 			link = link->next;
-			ql_remove_link(&ha->dev[index], &tq->device);
-			ql_dev_free(ha, tq);
+
+			/* workaround FW issue, do implicit logout */
+			/* Never logo to the reused loopid!! */
+			if ((tq->loop_id != 0x7ff) &&
+			    (tq->loop_id != 0x7fe)) {
+				if (found == 0) {
+					rval = ql_get_port_database(ha,
+					    tq, PDF_NONE);
+					if ((rval == QL_SUCCESS) &&
+					    (tq->master_state ==
+					    PD_STATE_PORT_LOGGED_IN)) {
+						EL(ha, "nport id (%xh) "
+						    "loop_id=%xh "
+						    "reappeared\n",
+						    tq->d_id.b24,
+						    tq->loop_id);
+						bcopy((void *)&tq->port_name[0],
+						    (void *)&ha->n_port->
+						    port_name[0],
+						    8);
+						bcopy((void *)&tq->node_name[0],
+						    (void *)&ha->n_port->
+						    node_name[0],
+						    8);
+						ha->n_port->d_id.b24 =
+						    tq->d_id.b24;
+						found = 1;
+						continue;
+					}
+				}
+				(void) ql_logout_fabric_port(ha, tq);
+			}
+
+			tq->loop_id = PORT_NO_LOOP_ID;
 		}
 	}
 
+	if (found == 1) {
+		QL_PRINT_10(ha, "done found\n");
+		return;
+	}
+
+	tq = &tmp_tq;
+
 	/*
 	 * If the N_Port's WWPN is larger than our's then it has the
 	 * N_Port login initiative.  It will have determined that and
@@ -3017,16 +3177,14 @@
 	tq->loop_id = 0x7fe;
 
 	rval = ql_get_port_database(ha, tq, PDF_NONE);
-	if (rval == QL_SUCCESS || rval == QL_NOT_LOGGED_IN) {
-		ql_dev_id_list_t	*list;
-		uint32_t		list_size;
-		ql_mbx_data_t		mr;
-		port_id_t		d_id = {0, 0, 0, 0};
-		uint16_t		loop_id = 0;
 
-		cb_port_name = (uint8_t *)(CFG_IST(ha, CFG_CTRL_24258081) ?
-		    &ha->init_ctrl_blk.cb24.port_name[0] :
-		    &ha->init_ctrl_blk.cb.port_name[0]);
+	/*
+	 * Only collect the P2P remote port information in the case of
+	 * QL_SUCCESS. FW should have always logged in (flogi) to remote
+	 * port at this point.
+	 */
+	if (rval == QL_SUCCESS) {
+		cb_port_name = &ha->loginparams.nport_ww_name.raw_wwn[0];
 
 		if ((ql_wwn_cmp(ha, (la_wwn_t *)&tq->port_name[0],
 		    (la_wwn_t *)cb_port_name) == 1)) {
@@ -3045,19 +3203,23 @@
 		/* Resolve an n_port_handle */
 		ha->n_port->n_port_handle = 0x7fe;
 
-		list_size = sizeof (ql_dev_id_list_t) * DEVICE_LIST_ENTRIES;
-		list = (ql_dev_id_list_t *)kmem_zalloc(list_size, KM_SLEEP);
+	}
 
-		if (list != NULL &&
-		    ql_get_id_list(ha, (caddr_t)list, list_size, &mr) ==
-		    QL_SUCCESS) {
-			if (mr.mb[1]) {
-				EL(ha, "id list entries = %d\n", mr.mb[1]);
-				for (index = 0; index < mr.mb[1]; index++) {
-					ql_dev_list(ha, list, index,
-					    &d_id, &loop_id);
-					ha->n_port->n_port_handle = loop_id;
-				}
+	list_size = sizeof (ql_dev_id_list_t) * DEVICE_LIST_ENTRIES;
+	list = (ql_dev_id_list_t *)kmem_zalloc(list_size, KM_SLEEP);
+
+	if (ql_get_id_list(ha, (caddr_t)list, list_size, &mr) ==
+	    QL_SUCCESS) {
+			/* For the p2p mr.mb[1] must be 1 */
+			if (mr.mb[1] == 1) {
+				index = 0;
+				ql_dev_list(ha, list, index,
+				    &d_id, &loop_id);
+				ha->n_port->n_port_handle = loop_id;
+
+				tq->loop_id = loop_id;
+				tq->d_id.b24 = d_id.b24;
+				ha->n_port->d_id.b24 = d_id.b24;
 			} else {
 				for (index = 0; index <= LAST_LOCAL_LOOP_ID;
 				    index++) {
@@ -3071,23 +3233,64 @@
 							ha->n_port->
 							    n_port_handle =
 							    tq->loop_id;
+							ha->n_port->d_id.b24 =
+							    tq->hard_addr.b24;
 							break;
 						}
-					} else {
+					} else if (rval == QL_SUCCESS) {
 						ha->n_port->n_port_handle =
 						    tq->loop_id;
+						ha->n_port->d_id.b24 =
+						    tq->hard_addr.b24;
+
 						break;
 					}
 				}
+				if (index > LAST_LOCAL_LOOP_ID) {
+					EL(ha, "P2P:exceeded last id, "
+					    "n_port_handle = %xh\n",
+					    ha->n_port->n_port_handle);
+
+					ha->n_port->n_port_handle = 0;
+					tq->loop_id = 0;
+				}
 			}
 		} else {
-			cmn_err(CE_WARN, "!%s(%d) didn't get list for %xh",
-			    QL_NAME, ha->instance, d_id.b24);
-		}
-		if (list != NULL) {
 			kmem_free(list, list_size);
+			EL(ha, "ql_get_dev_list unsuccessful\n");
+			return;
 		}
-	}
+
+		/* with the tq->loop_id to get the port database */
+
+		rval = ql_get_port_database(ha, tq, PDF_NONE);
+
+		if (rval == QL_NOT_LOGGED_IN) {
+			if (tq->master_state == PD_STATE_PLOGI_PENDING) {
+				bcopy((void *)&tq->port_name[0],
+				    (void *)&ha->n_port->port_name[0], 8);
+				bcopy((void *)&tq->node_name[0],
+				    (void *)&ha->n_port->node_name[0], 8);
+				bcopy((void *)&tq->hard_addr,
+				    (void *)&ha->n_port->d_id,
+				    sizeof (port_id_t));
+				ha->n_port->d_id.b24 = d_id.b24;
+			}
+		} else if (rval == QL_SUCCESS) {
+			bcopy((void *)&tq->port_name[0],
+			    (void *)&ha->n_port->port_name[0], 8);
+			bcopy((void *)&tq->node_name[0],
+			    (void *)&ha->n_port->node_name[0], 8);
+			bcopy((void *)&tq->hard_addr,
+			    (void *)&ha->n_port->d_id, sizeof (port_id_t));
+			ha->n_port->d_id.b24 = d_id.b24;
+
+		}
+
+		kmem_free(list, list_size);
+
+		EL(ha, "d_id = %xh, nport_handle = %xh, tq->loop_id = %xh",
+		    tq->d_id.b24, ha->n_port->n_port_handle, tq->loop_id);
 }
 
 
@@ -3112,7 +3315,7 @@
 	uint32_t	state;
 	ql_mbx_data_t	mr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Get host addresses. */
 	rval = ql_get_adapter_id(ha, &mr);
